
#include <stdio.h>
#define MAXODE 50

double atof();
char *get_first();

/*   this file has all of the phaseplane parameters defined   
     and created.  All other files should use external stuff
    to use them. (Except eqn forming stuff)
 */


 
 double last_ic[MAXODE];

 extern char big_font_name[100],small_font_name[100];
 extern int PaperWhite;

 (*solver)();
 adams();
 char delay_string[MAXODE][80];
 int itor[MAXODE];
 char this_file[100];
 float oldhp_x,oldhp_y,my_pl_wid,my_pl_ht;
 int mov_ind;
 int  storind,STORFLAG,INFLAG,MAXSTOR;
 double x_3d[2],y_3d[2],z_3d[2];
 int IXPLT,IYPLT,IZPLT;
 int AXES,TIMPLOT,PLOT_3D;
 double MY_XLO,MY_YLO,MY_XHI,MY_YHI;
 double TOR_PERIOD;
 int TORUS;
 int NEQ;
 char options[100];  

/*   Numerical stuff ....   */

 double DELTA_T,TEND,T0,TRANS,
	NULL_ERR,EVEC_ERR,NEWT_ERR;
 double BOUND,DELAY,TOLER,HMIN,HMAX;
 double BVP_EPS,BVP_TOL;

 double POIPLN;


 int NMESH,NJMP,METHOD,color_flag,NC_ITER;
 int EVEC_ITER;
 int BVP_MAXIT,BVP_FLAG;

 int POIMAP,POIVAR,POISGN,SOS;
   int FFT,NULL_HERE,POIEXT;
  int HIST,HVAR,hist_ind,FOREVER;

 /*  control of range stuff  */

 int PAUSER,ENDSING,SHOOT,PAR_FOL;


 extern int PSFlag;
 extern int make_cfile;

load_eqn(argc,argv)
int argc;
char **argv;
{
 int no_eqn=1,okay=0;
 FILE *fptr;
 make_cfile=0;
 /* if(argc<2)no_eqn=1;*/
 if(argc>3){
   printf(" \n xpp <filename> (-m) \n");
   exit(0);
 }
 if(argc==3&&strncmp(argv[2],"-m",2)==0){
   make_cfile=1;
   goto zippy;
 }
 if(argc==2&&strncmp(argv[1],"-m",2)==0){
   make_cfile=1;
 }
 if(argc==2&&strncmp(argv[1],"-m",2)!=0){
zippy:    strcpy(this_file,argv[1]);

  if((fptr=fopen(this_file,"r"))!=NULL)
  {
   okay=get_eqn(fptr);
   fclose(fptr);
   if(okay==1)no_eqn=0;
  }
  }
 if(no_eqn)
 {
    while(okay==0)
    {
      okay=make_eqn();
     }
}

}


set_all_vals()
{
 int i;
 FILE *fp;
 TIMPLOT=1;
 FOREVER=0;
 BVP_TOL=1.e-5;
 BVP_EPS=1.e-5;
 BVP_MAXIT=20;
 BVP_FLAG=0;
 PaperWhite=0;
 strcpy(big_font_name,"9x15");
 strcpy(small_font_name,"fixed");
 NMESH=40;
 NJMP=1;
 SOS=0;
 FFT=0;
 HIST=0;
 PSFlag=0;
 AXES=3;
 TOLER=0.001;
 DELAY=0.0;
 HMIN=0.0001;
 EVEC_ITER=100;
 EVEC_ERR=.001;
 NULL_ERR=.001;
 NEWT_ERR=.001;
 NULL_HERE=0;

 HMAX=1.000;
 POIMAP=0;
 POIVAR=1;
 POIEXT=0;
 POISGN=1;
 POIPLN=0.0;

 storind=0;
 mov_ind=0;


 STORFLAG=0;


 INFLAG=0;
 oldhp_x=-100000.0 ;
 oldhp_y=-100000.0;
 solver=adams;
 PLOT_3D=0;
 METHOD=4;
 MY_XLO=0.0;
 MY_XHI=20.0;
 MY_YLO=-1;
 MY_YHI=1;
 BOUND=100;
 MAXSTOR=5000;
 my_pl_wid=10000. ;
 my_pl_ht=7000.  ;
 for(i=0;i<MAXODE;i++)
 {
  itor[i]=0;
/*  last_ic[i]=0.0; */
  strcpy(delay_string[i],"0.0");
 }
 TORUS=0;
 T0=0.0;
 TRANS=0.0;
 DELTA_T=.05;
 x_3d[0]=-12;
 x_3d[1]=12;
 y_3d[0]=-12;
 y_3d[1]=12;
 z_3d[0]=-12;
 z_3d[1]=12;
 TEND=20.00;
 TOR_PERIOD=6.283185308;
 IXPLT=0;
 IYPLT=1;
 IZPLT=1;
 if(NEQ > 2)IZPLT=2;

 if((fp=fopen(options,"r"))!=NULL)
 {
  read_defaults(fp);
  fclose(fp);
 }
 if(IZPLT>NEQ)IZPLT=NEQ;
 if(IYPLT>NEQ)IYPLT=NEQ;
 init_stor(MAXSTOR,NEQ+1);
 alloc_h_stuff();
}


 read_defaults(fp)
 FILE *fp;
 {
 char bob[100];
 char *ptr;
 fgets(bob,80,fp);
 ptr=get_first(bob," ");
 strcpy(big_font_name,ptr);

 fgets(bob,80,fp);
 ptr=get_first(bob," ");
 strcpy(small_font_name,ptr);
 
 fil_int(fp,&PaperWhite);
 fil_int(fp,&IXPLT);
 fil_int(fp,&IYPLT);
 fil_int(fp,&IZPLT);
 fil_int(fp,&AXES);
 fil_int(fp,&NJMP);
 fil_int(fp,&NMESH);
 fil_int(fp,&METHOD);

 fil_int(fp,&TIMPLOT);
 fil_int(fp,&MAXSTOR);
 fil_flt(fp,&TEND);
 fil_flt(fp,&DELTA_T);
 fil_flt(fp,&T0);
 fil_flt(fp,&TRANS);
 fil_flt(fp,&BOUND);
 fil_flt(fp,&HMIN);
 fil_flt(fp,&HMAX);
 fil_flt(fp,&TOLER);
 fil_flt(fp,&DELAY);
 fil_flt(fp,&MY_XLO);
 fil_flt(fp,&MY_XHI);
 fil_flt(fp,&MY_YLO);
 fil_flt(fp,&MY_YHI);

 
}

fil_flt(fpt,val)
FILE *fpt;
double *val;
{
 char bob[80];
 fgets(bob,80,fpt);
 *val=atof(bob);
}

fil_int(fpt,val)
int *val;
FILE *fpt;
{
 char bob[80];
 fgets(bob,80,fpt);
 *val=atoi(bob);
}






