#include <curses.h>
#include <string.h>
#include <math.h>
#include "my_pars.h"
#include "shoot.h"

#define MAXODE 50

BC_STRUCT my_bc[MAXODE];;
int *my_ode[MAXODE];
char *ode_names[MAXODE];
char upar_names[200][11];
char *save_eqn[80];
double default_val[200];
extern double last_ic[];
int NODE,NUPAR,NLINES;
int NCON_START,NSYM_START;
 int BVP_NL,BVP_NR,BVP_N;
 extern int BVP_FLAG;
int IN_VARS;
int FIX_VAR;
int leng[MAXODE];
int ICREATE=0;
extern int NEQ;
extern int NCON,NSYM;
extern char this_file[100];
extern char options[100];
char uvar_names[MAXODE][12];
int make_cfile;
int start_ode,start_fix;
get_eqn(/* FILE *fptr */);
char *get_first(/* char *string,char *src */);
char *get_next(/* char *src */);
take_apart(/* char *bob, double *value, char *name */);
char *getsi();
double atof();
  make_eqn()
  {
   char ch;
   int okay,i;
   char num[5];

   NEQ=2;
   FIX_VAR=0;
   initscr();
   pos_prn("*(r)ead or (c)reate:",0,0);
   ch=getuch();
   okay=0;
   switch(ch)
   {
    case 'r':okay=read_eqn(); break;
    case 'c':okay=create_eqn();break;
      default : read_eqn();break;
   }


   return(okay);
  }

  disc(string)
char *string;
  {
   char *ptr;
   char bob[200];
   strcpy(bob,string);
   ptr=strtok(bob,".");
   ptr=strtok(NULL,"");
   if(strcmp(ptr,"dis")==0||strcmp(ptr,"dif")==0)return(1);
   return(0);
  }

  read_eqn()
  {
   char string[200];
   FILE *fptr;
   int okay,i;
   okay=0;
getfile:
   pos_prn("File to read or <Enter> for directory:",0,0);
   getsi(string);
   if(strlen(string)==0)
   {
    get_dir();
    goto getfile;
   }
   if((fptr=fopen(string,"r"))==NULL)
   {
    printf("\n Cannot open %s \n",string);
    return(0);
   }
   strcpy(this_file,string);
   clrscr();
   okay=get_eqn(fptr);
   close(fptr);
   for(i=0;i<NLINES;i++)free(save_eqn[i]);
   return(okay);
 }

get_dir()

{
 FILE *fptr;
 char path[100];
 char commd[200];
 printf("Path <*.ode>");
 gets(path);
 if(strlen(path)==0)strcpy(path,"*.ode");
/***********************
 sprintf(commd,"ls %s > temp",path);
 system(commd);
 fptr= fopen("temp","r");
 while(!feof(fptr))
 {
  fgets(path,100,fptr);
  printf("%s",path);
 }
 fclose(fptr);
 system("rm temp");
 *******************************/
  sprintf(commd,"ls %s",path);
  system(commd);
 }

 

 



  get_eqn(fptr)
 FILE *fptr;
  {
    char bob[256],num[5];
    int done=1,nn,i;
    char prim[15];
    init_rpn();
    NLINES=0;
    IN_VARS=0;
    NODE=0;
    BVP_N=BVP_NL=BVP_NR=0;
    NUPAR=0;
    strcpy(options,"default.opt");
    add_var("t",0.0);
    printf(" NEQ: ");
    fgets(bob,256,fptr);
    nn=strlen(bob)+1;
    if((save_eqn[NLINES]=(char *)malloc(nn))==NULL)exit(0);
    strncpy(save_eqn[NLINES++],bob,nn);
    NEQ=atoi(bob);
    if(NEQ<=0)exit(0);
    if(fptr!=stdin)printf("=%d\n",NEQ);
    if(make_cfile==1){
      open_cfiles();
      start_ode=0;
      start_fix=0;
    }
    while(done)
    {
     fgets(bob,256,fptr);
    nn=strlen(bob)+1;
    if((save_eqn[NLINES]=(char *)malloc(nn))==NULL)exit(0);
     strncpy(save_eqn[NLINES++],bob,nn);
     done=compiler(bob);
    }
    if(make_cfile==1){
      if(start_ode==1)end_ode();
      if(start_fix==1)end_fixed();
        close_cfiles();
    }
    if(BVP_N>NODE){
      printf("Too many boundary conditions\n");
      exit(0);
    }
    if(BVP_N<NODE){
      for(i=BVP_N;i<NODE;i++){
	my_bc[i].com=(int *)malloc(100*sizeof(int));
	my_bc[i].string=(char *)malloc(80);
	my_bc[i].name=(char *)malloc(10);
	my_bc[i].side=0;
	strcpy(my_bc[i].string,"0");
	strcpy(my_bc[i].name,"0=");
      }
    }
    BVP_FLAG=1;

    if(NODE!=NEQ+FIX_VAR)
    {
     printf(" Too many/few equations\n");
     exit(0);
    }
    if(IN_VARS>NEQ)
    {
     printf(" Too many variables\n");
     exit(0);
    }
    NODE=IN_VARS;
     for(i=NODE;i<NEQ;i++)
     {
      sprintf(uvar_names[i],"AUX%d",i-NODE+1);
       }
    for(i=0;i<NEQ;i++)
    {
     strupr(uvar_names[i]);
     strupr(ode_names[i]);
    }
    /*
     add primed variables                              */
   add_var("t'",0.0);
   for(i=0;i<NODE;i++){
     sprintf(prim,"%s'",uvar_names[i]);
     add_var(prim,0.0);
   }
    
   /*  add auxiliary variables   */
   for(i=NODE;i<NEQ;i++)add_var(uvar_names[i],0.0); 
   NCON_START=NCON;
   NSYM_START=NSYM;
    return(1);
 }

   write_eqn()
   {
    char string[100];
    FILE *fptr;
    int i;
    if(NLINES==0)
    {
     printf(" There is no current equation!\n");
     exit(0);
    }
    wipe_out();
    pos_prn("Name of file to save:",0,0);
    getsi(string);
    if((fptr=fopen(string,"w"))==NULL)
    {
     printf("\nCannot open %s\n",string);
     return;
    }
    strcpy(this_file,string);
    for(i=0;i<NLINES;i++)
    {
     fputs(save_eqn[i],fptr);
     free(save_eqn[i]);
    }
    fclose(fptr);
   }


  create_eqn()
  {
    int okay;
    FILE *fptr;
    wipe_out();
     fptr=stdin;
   welcome();
   okay=get_eqn(fptr);
   if(okay==1)write_eqn();
   return(okay);
  }

  wipe_out()
{
   clrscr();
  }


 compiler(bob)
 char *bob;
 {
 double value;
 int narg,done,nn,iflg=0;
 char *ptr,*my_string,*command;
 char name[20],formula[256];
 char temp[20];
  ptr=bob;
  done=1;
 command=get_first(ptr," ,");
 strlwr(command);
 switch(*command)
 {
  case 'd': done=0;
            break;
  case 's': show_syms();
	    break;
  case 'h': welcome();
            break;
  case 'p':
           printf("Parameters:\n");
           while((my_string=get_next(" ,\n"))!=NULL)
           {
            take_apart(my_string,&value,name);
            default_val[NUPAR]=value;
            strcpy(upar_names[NUPAR++],name);
            printf("|%s|=%f ",name,value);
            if(add_con(name,value))exit(0);
	    if(make_cfile==1)name_param(name,NCON-1);
           }
           printf("\n");
           break;
  case 'c': my_string=get_next(" \n");
	    strcpy(options,my_string);
	    break;
  case 'f':iflg=0;
	   printf("\nFixed variables:\n");
	   goto vrs;
  case 'v':
	   iflg=1;
	   printf("\nVariables:\n");
   vrs:
           while((my_string=get_next(" ,\n"))!=NULL)
           {
                       if((IN_VARS>NEQ)||(IN_VARS==MAXODE))
                       {
                         printf(" too many variables\n");
                         exit(0);
                       }

            take_apart(my_string,&value,name);
            if(add_var(name,value))exit(0);
            if(iflg)
	    {
	     strcpy(uvar_names[IN_VARS],name);
	     last_ic[IN_VARS]=value;
	     if(make_cfile==1)name_var(name,IN_VARS);
	     IN_VARS++;
	    }
	    else {
	      FIX_VAR++;
	      if(make_cfile==1)name_fixed(name);
	    }
            printf("|%s| ",name);

           }
           printf(" \n");
           break;
  case 'b':
   /* my_string=get_next(" ");
    narg=atoi(my_string);
    if(narg!=1)narg=0; */
    my_string=get_next("\n");
    my_bc[BVP_N].com=(int *)malloc(100*sizeof(int));
    my_bc[BVP_N].string=(char *)malloc(80);
    my_bc[BVP_N].name=(char *)malloc(10);
    strcpy(my_bc[BVP_N].string,my_string);
    strcpy(my_bc[BVP_N].name,"0=");

 /*  my_bc[BVP_N].side=narg; 
      if(narg==0){
      BVP_NL++;
      strcpy(my_bc[BVP_N].name,"0=");
    }
    else {
       BVP_NR++;
      strcpy(my_bc[BVP_N].name,"0=");
     }
  */
  
    
    printf("|%s| |%s| \n",my_bc[BVP_N].name,my_bc[BVP_N].string);
    BVP_N++;
    break;
    
  case 'u':
          my_string=get_next(" ");
          strcpy(name,my_string);
          my_string=get_next(" ");
          narg=atoi(my_string);
          my_string=get_next("$");
          strcpy(formula,my_string);
          printf("%s %d :\n",name,narg);
          if(add_ufun(name,formula,narg))exit(0);
          if(make_cfile==1)add_user_fun_form(name,narg,formula);
          printf("user %s = %s\n",name,formula);
          break;
  case 'o':
          if(NODE>=(NEQ+FIX_VAR))
          {
           done=0;
           break;
          }
          my_string=get_next("\n");
          strcpy(formula,my_string);
          nn=strlen(formula)+1;
	  if(nn>79)nn=79;
          if((my_ode[NODE]=(int *)malloc(400))==NULL)exit(0);
          if(NODE<IN_VARS)
	  {
           if((ode_names[NODE]=(char *)malloc(nn+1))==NULL)exit(0);
          strncpy(ode_names[NODE],formula,nn);
	  ode_names[NODE][nn]='\0';
	   if(make_cfile==1){
	     if(start_ode==0)start_ode_form(FIX_VAR);
	     start_ode=1;
	     add_ode_rhs(NODE,formula);
	   }
	  }
          if(NODE>=IN_VARS&&NODE<(IN_VARS+FIX_VAR))
	     {
	       if(make_cfile==1){
		 if(start_ode){
		   end_ode();
		   start_ode=0;
		 }
		 if(start_fix==0){
		   start_fix=1;
		   start_fixed_form();
		 }
		 add_fixed_rhs(NODE-IN_VARS,formula);
		}
	     }
	      
		
	  if(NODE>=(IN_VARS+FIX_VAR))
          {
	    if(start_ode==1){
	      end_ode();
	      start_ode=0;
	    }
      	    if(start_fix==1){
	     end_fixed();
	     start_fix=0;
	   }
	  if((ode_names[NODE-FIX_VAR]=(char *)malloc(nn+1))==NULL)exit(0);
          strncpy(ode_names[NODE-FIX_VAR],formula,nn);
	  ode_names[NODE-FIX_VAR][nn]='\0';
	  }
          printf("RHS(%d)=%s\n",NODE,formula);
          if(add_expr(formula,my_ode[NODE],&leng[NODE]))exit(0);
	  /* for(narg=0;narg<leng[NODE];narg++) printf(" %d %d \n",narg,my_ode[NODE][narg]); */
          NODE++;
          break;

 }

         return(done);
}
list_upar()
{
 int i;
 for(i=0;i<NUPAR;i++)printf(" %s",upar_names[i]);
}

welcome()
{
 printf("\n The commands are: \n");
 printf(" P(arameter) -- declare parameters <name1>=<value1>,<name2>=<value2>,...\n");
 printf(" F(ixed)     -- declare fixed variables\n");
 printf(" V(ariables) -- declare ode variables \n");
 printf(" U(ser)      -- declare user functions <name> <nargs> <formula>\n");
 printf(" C(hange)    -- change option file   <filename>\n");
 printf(" O(de)       -- declare RHS for equations\n");
 printf(" D(one)      -- finished compiling formula\n");
 printf(" H(elp)      -- this menu                 \n");
 printf(" S(ymbols)   -- Valid functions and symbols\n");
 printf("_________________________________________________________________________\n");

}

show_syms()
{
 printf("(    ,    )    +    -      *    ^    **    / \n");
 printf("sin  cos  tan  atan  atan2 acos asin\n");
 printf("exp  ln   log  log10 tanh  cosh sinh \n");
 printf("max  min  heav flr   mod   sign sqrt \n");
 printf("t    pi   ran  \n");
}

take_apart(bob, value, name)
char *bob,*name;
double *value;
{
 int k,i,l;
 char number[40];
 l=strlen(bob);
 k=strcspn(bob,"=");
 if(k==l)
 {
  *value=0.0;
  strcpy(name,bob);
  }
  else
  {
  strncpy(name,bob,k);
  name[k]='\0';
  for(i=k+1;i<l;i++)number[i-k-1]=bob[i];
  number[l-k-1]='\0';
  *value=atof(number);
  }
}

char *get_first(string,src)
char *string,*src;
{
 char *ptr;
 ptr=strtok(string,src);
 return(ptr);
}
char *get_next(src)
char *src;
{
 char *ptr;
 ptr=strtok(NULL,src);
 return(ptr);
}


pos_prn(s,x,y)
char *s;
int x,y;
{
 printf("%s\n",s);
 }

clrscr()
{
 system("clear");
 }



  getuch()
{
 int ch;
 ch=getchi();
 if(ch>64&&ch<96)ch+=32;
 return(ch);
}


/***   remove this for full PP   ***/

 getchi()
 {
  return(getch());
 }

  char *getsi( bob)
  char *bob;
  {
   return(gets(bob));
  }







