#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>
#include <X11/bitmaps/icon>
#include <math.h>
#include "pp.bitmap"
#include <stdio.h>
#include "help_defs.h"
#include "struct.h"
#include <X11/cursorfont.h>
#define BITMAPDEPTH 1
#define TOO_SMALL 0
#define BIG_ENOUGH 1

extern char this_file[100];
extern int METHOD,storind;
extern (*rhs)();

my_rhs();

char big_font_name[100],small_font_name[100];
int PaperWhite;

char mycommand[100];
static char *progname;
Window init_win();
Window win;
Window draw_win;

Window main_win;
Window menu_pop,command_pop,info_pop;
GC gc, gc_graph,small_gc;
extern int help_menu,current_pop;
unsigned long Black,White;
unsigned long MyBackColor,MyForeColor;
unsigned long GrFore,GrBack;
int SCALEX,SCALEY;
extern int COLOR;
Display *display;
int screen;
extern int periodic;
int DCURYb,DCURXb,CURY_OFFb;
int DCURYs,DCURXs,CURY_OFFs;
int DCURY,DCURX,CURY_OFF;

 XFontStruct *big_font,*small_font;

 int popped=0;

main(argc,argv)
char **argv;
int argc;
{

  char *icon_name="xpp";
/*  char *win_name="PHASEPLANE Ver.-1"; */
 char *win_name;
 char pptitle[80];
 int count;

 unsigned int min_wid=450,min_hgt=360;
 unsigned int x=0,y=0;
 SCALEX=640;
 SCALEY=450;


 load_eqn(argc,argv);   
  set_all_vals();
 init_range();
 if(disc(this_file))METHOD=0;
 if(strlen(this_file)<60)
 sprintf(pptitle,"XPP >> %s",this_file);
 else sprintf(pptitle,"XPP Version -1");
 win_name=pptitle;
 do_meth();
 rhs=my_rhs;




 main_win=init_win(4,icon_name,win_name,
   x,y,min_wid,min_hgt,argc,argv);
 win=main_win;
periodic=1;
if(DefaultDepth(display,screen)>=8)COLOR=1;
else COLOR=0;
/* if(DefaultDepth(display,screen)==4){
map16();
COLOR=1;
} */
XSelectInput(display,win,ExposureMask|KeyPressMask|ButtonPressMask|
              StructureNotifyMask);
load_fonts();
DCURXb=XTextWidth(big_font,"W",1);
DCURYb=big_font->ascent+big_font->descent;
CURY_OFFb=big_font->ascent+1;
DCURXs=XTextWidth(small_font,"W",1);
DCURYs=small_font->ascent+small_font->descent;
CURY_OFFs=small_font->ascent+1;


 Black=BlackPixel(display,screen);
White=WhitePixel(display,screen);  
/*  Switch for reversed video  */
MyForeColor=GrFore=Black;
MyBackColor=GrBack=White;
/*  This is reversed  
MyForeColor=White;
MyBackColor=Black; */
if(PaperWhite==0){
GrFore=White;
GrBack=Black; 
}
getGC(&gc);
getGC(&gc_graph);
getGC(&small_gc);
if(COLOR)MakeColormap(); 

set_big_font(); 
/* set_small_font(); */

XSetFont(display,small_gc,small_font->fid);
XMapWindow(display,win);

 make_pops();


/*   This is for testing widgets  ---    */



initialize_box();

init_browser();
create_eq_list();






/*          MAIN LOOP             */

do_events(min_wid,min_hgt);
} 


set_big_font()
{
 DCURX=DCURXb;
 DCURY=DCURYb;
 CURY_OFF=CURY_OFFb;
 XSetFont(display,gc,big_font->fid);
}

set_small_font()
{
  DCURX=DCURXs;
 DCURY=DCURYs;
 CURY_OFF=CURY_OFFs;
 XSetFont(display,gc,small_font->fid);
}





do_events(min_wid,min_hgt)
unsigned int min_wid,min_hgt;  
{
 XEvent report;
 int window_size,com;
 char string[100];
 char ch;
 int i1=-1,i2;
 int used;
  blank_screen(main_win);
  help();
 
while(1)
{
/*  put_command("Command:");  */
 XNextEvent(display,&report);
 do_box_events(report,&i1);
 switch(report.type){
 case Expose:
 case MapNotify:
	if(report.xany.window==command_pop)put_command("Command:");
     do_expose(report);
  resize_my_browser(report.xany.window);
  resize_eq_list(report.xany.window);  
   break;
 case ConfigureNotify:


  if(report.xconfigure.window==main_win){

  SCALEX=report.xconfigure.width;
  SCALEY=report.xconfigure.height;
  if((SCALEX<min_wid) || (SCALEY<min_hgt)){
   window_size=TOO_SMALL;
  SCALEX=min_wid;
  SCALEY=min_hgt;}
  else {
   window_size=BIG_ENOUGH;
   XResizeWindow(display,command_pop,SCALEX-4,DCURY+1);
   XMoveResizeWindow(display,info_pop,0,SCALEY-4*DCURY-4,SCALEX-4,4*DCURY);
   resize_all_pops(SCALEX,SCALEY);

    }
  }

  break;

 case KeyPress:
                eq_list_keypress(report,&used);
                if(used)break;
                my_browse_keypress(report,&used);
		 if(used)break;		 
	             ch=(char)get_key_press(&report);
		commander(ch);
	    
	    /* do_key_stuff(report); */


               break;
case ButtonPress:
                eq_list_button(report);
		my_browse_button(report);
		if(show_position(report,&com)==1) 
		 point_com(com); 
		 break;


 } /* end switch */
 } /* end while */
}



bye_bye()
{
   XUnloadFont(display,big_font->fid);
  XUnloadFont(display,small_font->fid);
 XFreeGC(display,gc);
XCloseDisplay(display);
 exit(1);
}

 commander(ch)
 char ch;
 {
   switch(help_menu)
  {
      case MAIN_HELP:
  	{ 
          switch(ch)
		{
		case 'i':flash(0);
			/*  initial data  */
		        do_init_data();
				 flash(0);
			 break;
		case 	'c':flash(1);
			 /* continue */
		         cont_integ();
     		  			 flash(1);
			 break;
		case 'n':flash(2);
			 /*nullclines */
		         new_clines();
			 flash(2);
			 break;
		case 'd':flash(3);
			 /*dir fields */
		         direct_field();
			 flash(3);
			 break;
		case 'w':flash(4);
			 /* window */
		         window_zoom();
			 flash(4);
			 break;
		case 'a':flash(5);
			 /*phase-space */
		         do_torus();
			 flash(5);
			 break;
		case 'k':flash(6);
			 /*kinescope */
			 do_movie();
			 flash(6);
			 break;
		case 'g' :flash(7);
			  flash(7);
			  add_a_curve();
			  break;
		case 'u':flash(8);
			 flash(8);
			 help_num();
			 break;
		case 'f':flash(9);
			 /* files */
			 flash(9);
			help_file();
			break;
		case 'p':flash(10);
			 /*parameters */
			 change_par(-1);
			 flash(10);
			 break;
		case 'e':flash(11);
			 /*erase */
			  blank_screen(draw_win);
			 restore_off();
			 do_axes();
			 hi_lite(draw_win);

 			 destroy_label(draw_win);
			 flash(11);
			 break;
		case 'h':flash(12);
                         do_windows();
			 /*half windows */
			 flash(12);
			 break;
		case 't':flash(13);
			 /*text */
			 put_text();
			 flash(13);
			 break;
		case 's':flash(14);
			 /*sing pts */
		         find_equilibrium();
			 flash(14);
			 break;
		case 'v':flash(15);
			 /*view_axes */
		        change_view();
			 flash(15);
			 break;
		case 'b':
		        find_bvp();
		        break;
                        
		case 'x':flash(16);
			 /*x vs t */
		  x_vs_t();
			 flash(16);
			 break;
		case 'r':flash(17);
			 /*restore*/
			 restore(0,storind);
			 flash(17);
			 break;
		case '3': get_3d_par();
			 break;


                 } /* End main switch  */
		
   
            } /* MAIN HELP ENDS  */ break;

	case NUM_HELP:{
 			get_num_par(ch);
         	   } /* end num case   */ break;

	case THREED_HELP: {
	 switch(ch){
		
		case 'x': flash(0);
			/* x-3d */
			flash(0);
			break;

		case 'y': flash(1);
			/* y-3d */
			flash(1);
			break;
		case 'z': flash(2);
			/* z-3d */
			flash(2);
			break;
		case 'c': flash(3);
			/* clear rot */
			flash(3);
			break;
		case 'f': flash(4);
			/* fit 3d*/
			flash(4);
			break;
		case 'p': flash(5);
			/* pivot */
			flash(5);
			break;
		case 'w': flash(6);
			/* window */
			flash(6);
			break;
		case 'r': flash(7);
			/* restore */
			XDrawLine(display,draw_win,gc_graph,0,0,200,200);
			flash(7);
			break;
		case 's': flash(8);
			/* perspective */
			flash(8);
			break;
		case 'k': flash(9);
			/* kinescope */
			do_movie();
			flash(9);
			break;
		case 27:help();
			break;
                } /* End 3d switch   */
           } /* end three d case  */ break;


      case FILE_HELP: {
          switch(ch){
		case 'p': flash(0);
			/* file stuff */
		        do_info(stdout);
			flash(0);
			break;
		case 'w': flash(1);
			/* write set */
		       do_lunch(0);
			flash(1);
			break;
		case 's': flash(2);
			/* make eqn */
		        file_inf();
			flash(2);
			break;
		case 'l': flash(3);
			/* list eqns */
			flash(3);
			break;
		case 'c': flash(4);
			/* calculator */
		        q_calc();

			flash(4);
			break;
		case 'r': flash(5);
			/* read set */
		        do_lunch(1);
			flash(5);
			break;
		case 'm': flash(6);
			/* script */
		        /*  Insert generic code here ...  */
			flash(6);
			break;
		case 'q': flash(7);
			if(yes_no_box())bye_bye();
			 
			/*  if(are_you_sure())bye_bye();  */
			
			/* quit */
			 flash(7);
			break;
                } /* end file switch  */
	        help();
            } /*  end file case   */ break;
      case GRAPH_HELP:{
	 switch(ch) {
		case 'g': flash(0);
			/* gr_dump */
			flash(0);
			break;
		case 'p': flash(1);
			/* plot_file */
			flash(1);
			break;
		case 'm': flash(2);
			/* marker */
			flash(2);
			break;
		case 'a': flash(3);
			/* axes */
			flash(3);
			break;
		case 'i': flash(4);
			/* invert */
		     
			flash(4);
			break;
                  } /* end graphics switch  */
		 help();
		} /* end graphics case  */ break;

       }  /* end help_menu switch  */

}


	


 Window init_win(bw,icon_name,win_name,
                 x,y,min_wid,min_hgt,argc,argv)
 int argc;
 char **argv;
 unsigned int min_wid,min_hgt,bw;
 char *icon_name,*win_name;
 {
  Window wine;
  int count;
  unsigned dp_h,dp_w;
  Pixmap icon_map;
 XIconSize *size_list;
  XSizeHints size_hints;
 char *display_name=NULL;
 if((display=XOpenDisplay(display_name))==NULL)exit(-1);
/*   Remove after debugging is done */   
/* XSynchronize(display,1); */
 screen=DefaultScreen(display);
 dp_w=DisplayWidth(display,screen);
 dp_h=DisplayHeight(display,screen);
 if(SCALEX>dp_w)SCALEX=dp_w;
 if(SCALEY>dp_h)SCALEY=dp_h;
 wine=XCreateSimpleWindow(display,RootWindow(display,screen),
     x,y,SCALEX,SCALEY,bw,MyForeColor,
     MyBackColor);
 XGetIconSizes(display,RootWindow(display,screen),&size_list,&count);
 icon_map=XCreateBitmapFromData(display,wine,
 pp_bits,pp_width,pp_height);

#ifdef X11R3
  size_hints.flags=PPosition|PSize|PMinsize;
 size_hints.x=x;
 size_hints.y=y;
 size_hints.width=width;
 size_hints.height=height;
 size_hints.min_width=min_wid;
 size_hints.min_height=min_hgt;
#else 

 size_hints.flags=PPosition|PSize|PMinSize;
 size_hints.min_width=min_wid;
 size_hints.min_height=min_hgt;
#endif

#ifdef X11R3
 XSetStandardProperties(display,wine,win_name, icon_name,icon_map,argv,
  argc,&size_hints);
#else 
 {
  XWMHints wm_hints;
  XClassHint class_hints;
  XTextProperty winname,iconname;
 if(XStringListToTextProperty(&icon_name,1,&iconname)==0)
 {
 printf("failure for iconname\n");
 exit(-1);
 }
if(XStringListToTextProperty(&win_name,1,&winname)==0)
 {
 printf("failure for winname\n");
 exit(-1);
 }
 
 wm_hints.initial_state=NormalState;
 wm_hints.input=True;
 wm_hints.icon_pixmap=icon_map;
 wm_hints.flags=StateHint|IconPixmapHint|InputHint;
 class_hints.res_name="base";
 class_hints.res_class="Basicwin";
 XSetWMProperties(display,wine,&winname,&iconname,argv,argc,&size_hints,&wm_hints,&class_hints);
}
#endif
 return(wine);
}

getGC(gc)
GC *gc;
{
 unsigned long valuemask=0;
 XGCValues values;
 unsigned int lw=6;
 int ls=LineOnOffDash;
 int cs=CapRound;
 int js=JoinRound;
 int dash_off=0;
 static char dash[]={12,24};
 int ll=2;
 *gc=XCreateGC(display,win,valuemask,&values);
 XSetForeground(display,*gc,MyForeColor);
/* XSetLineAttributes(display,*gc,lw,ls,cs,js);
 XSetDashes(display,*gc,dash_off,dash,ll); */
}

 load_fonts()

 {


  if((big_font=XLoadQueryFont(display,big_font_name))==NULL)
 {
  printf("Failed for  font %s\n",big_font_name);
  exit(-1);
 }
 /*  if((small_font=XLoadQueryFont(display,"fixed"))==NULL)
 {
  printf("Failed for fixed font\n");
  exit(-1);
 } */
  if((small_font=XLoadQueryFont(display,small_font_name))==NULL)
 {
  printf("Failed for fixed font %s\n",small_font_name);
  exit(-1);
 }

}


make_pops()

{  int x,y,h,w,bw,d;
   Window wn;
   Cursor cursor;
   XGetGeometry(display,main_win,&wn,&x,&y,&w,&h,&bw,&d);
 menu_pop=XCreateSimpleWindow(display,main_win,
     0,DCURY+6,16*DCURX,22*DCURY,2,MyForeColor,
     MyBackColor);
 command_pop=XCreateSimpleWindow(display,main_win,0,0,w-2,DCURY+4,2,
MyForeColor,
     MyBackColor);
 info_pop=XCreateSimpleWindow(display,main_win,0,h-4*DCURY-4,w-2,4*DCURY,2,
MyForeColor,
     MyBackColor);
 cursor=XCreateFontCursor(display,XC_hand2);
 XDefineCursor(display,menu_pop,cursor);
XSelectInput(display,menu_pop,KeyPressMask|ButtonPressMask|ExposureMask);
XSelectInput(display,command_pop,KeyPressMask|ButtonPressMask|ExposureMask);
 XMapWindow(display,info_pop);
 XMapWindow(display,command_pop);
 XMapWindow(display,menu_pop);
 init_grafs(16*DCURX+6,DCURY+6,w-16-16*DCURX,h-5*DCURY-16);
  get_draw_area(); 
 
}


/* 
dumb_clines()
{
 int x,y,type,key;
 create_null_chc();
 while(1){
 if(null_abort(&x,&y,&type,&key))
 switch(type){
 case 0:  printf(" New guess at %d %d \n",x,y);
   break;
 case 1:  printf(" Do XCline \n");
   break;
 case 2:  printf(" Do YCline \n");
   break;
 case 3:  kill_null_chc();
   return;
 case 4:  printf(" Pressed key %d \n",key);
   if(key==27)kill_null_chc();
   return;
 }

}
}
 */








